import csv

HEDONODATA = "Hedonometer.csv"
COUTDATA = "2016-2022_happiness/2022bookcouts.csv"

happyDict = {}

with open(HEDONODATA, encoding='utf-8') as csvf:
    csvReader = csv.DictReader(csvf)
        
    for row in csvReader:
        key = row['Word in English']
        val = row['Happiness Score']
        happyDict[key] = val

coutDict = {}

with open(COUTDATA, encoding='utf-8') as csvf:
    csvReader = csv.DictReader(csvf)

    for row in csvReader:
        datetime = row['cout']
        date = datetime[0:10]
        title = row['title']
        if date in coutDict and coutDict[date] is not None:
            coutDict[date].append(title)
        else:
            coutDict[date] = [title]

dates = list(coutDict.keys())
dates.sort()

dateRatings = []

irrelevant_words = ["the", "a", "and", "then", "miami","pearl", "santa", 
                    "atlantic", "grand", "green", "falls", "haven", "sin", "con", 
                    "gren","springfield","falling","international","terminal","mad", 
                    "al","ak","az","ar","ca","co","ct","de","fl","ga","hi","id","il",
                    "in","ia","ks","ky","la","me","md","ma","mi","mn","ms","mo","mt",
                    "ne","nv","nh","nj","nm","ny","nc","nd","oh","ok","or","pa","ri",
                    "sc","sd","tn","tx","ut","vt","va","wa","wv","wi","wy", "alabama", 
                    "alaska", "arizona", "arkansas", "california", "colorado", "connecticut", 
                    "delaware", "florida", "georgia", "hawaii", "idaho", "illinois", "indiana", 
                    "iowa", "kansas", "kentucky", "louisiana", "maine", "maryland", 
                    "massachusetts", "michigan", "minnesota", "mississippi", "missouri", 
                    "montana", "nebraska", "nevada", "new", "hampshire", "jersey", "mexico", 
                    "york", "north", "carolina", "dakota", "ohio", "oklahoma", "oregon", "pennsylvania",
                    "rhode", "island", "south", "carolina", "dakota", "tennessee", "texas", 
                    "utah", "vermont", "virginia", "washington", "west", "virginia", "wisconsin",]

holidays = ["2022-12-25", "2022-09-05", "2022-07-04", "2022-06-19", 
            "2022-01-01", "2022-01-17", "2022-02-21", "2022-05-30", 
            "2022-10-10", "2022-11-11", "2022-11-24", "2022-12-24"]

for date in dates:
    print(date,"/",len(dates))
    if date not in holidays:
        titles = coutDict[date]
        titleCount = 0
        dateHappy = 0
        for title in titles:
            titleScore = 0
            noHit = True
            if title is None:
                continue
            words = title.split(" ")
            wordCount = 0
            for word in words:
                word = word.lower()
                if word not in irrelevant_words:
                    if word in happyDict:
                        noHit = False
                        titleScore += float(happyDict[word])
                        wordCount +=1 
            if not noHit:
                titleCount += 1
                avgHappy = titleScore / wordCount
                dateHappy += avgHappy
        if not noHit:
            dateHappy = dateHappy/titleCount
            dateRatings.append({"Date": date, "Hedonometer": round(dateHappy, 3), "TitleCount": titleCount})


field_names = ["Date", "Hedonometer", "TitleCount"]

with open('HappinessPerDay2022.csv', 'w') as csvfile:
    writer = csv.DictWriter(csvfile, fieldnames=field_names)
    writer.writeheader()
    writer.writerows(dateRatings)       

        